## shark 3.0.1%2Bds1

=== include/CMakeLists.txt ===
INSTALL( DIRECTORY
	 ${CMAKE_CURRENT_SOURCE_DIR}/shark
	 DESTINATION DESTINATION ${SHARK_INSTALL_INCLUDE_DIR}
	 PATTERN ".*" EXCLUDE
)
