=== debian/changelog ===
shark (3.0.1+ds1-2ubuntu1) xenial; urgency=medium

  * Override testsuite for armhf i386 and powerpc,
    it has always failed there. 

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Wed, 06 Apr 2016 18:13:20 +0200

shark (3.0.1+ds1-2) unstable; urgency=medium

  * d/control: libshark-dev depends on libboost-dev.
  * d/tests/build-examples: build with Boost.
  * d/rules: fixup auto_test override.
  * Bump standards version to 3.9.7, no changes required.
  * libshark-dev: add missing install depends on blas and hdf5.
  * Fix build of examples in autopkgtest testsuite.
  * d/watch: fix filename mangling regex.
  * d/gbp.conf: change packaging branch to debian/master (DEP-14).

 -- Ghislain Antony Vaillant <ghisvail@gmail.com>  Tue, 15 Mar 2016 18:57:50 +0000

shark (3.0.1+ds1-1) unstable; urgency=low

  * Initial release. (Closes: #595485)

 -- Ghislain Antony Vaillant <ghisvail@gmail.com>  Thu, 26 Nov 2015 12:54:08 +0000
