=== doc/tools/Makefile ===

all:
	g++ -O3 -DNDEBUG -o tut2rst tut2rst.cpp

clean:
	rm -f tut2rst
