=== debian/control ===
Source: shark
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Ghislain Antony Vaillant <ghisvail@gmail.com>
Section: science
Testsuite: autopkgtest
Priority: optional
Build-Depends: cmake,
               debhelper (>= 9),
               libblas-dev | libblas.so,
               libboost-date-time-dev,
               libboost-filesystem-dev,
               libboost-program-options-dev,
               libboost-serialization-dev,
               libboost-system-dev,
               libboost-test-dev,
               libboost-thread-dev,
               libhdf5-dev
Build-Depends-Indep: doxygen,
                     graphviz,
                     python-sphinx
Standards-Version: 3.9.7
Vcs-Browser: https://anonscm.debian.org/cgit/debian-science/packages/shark.git
Vcs-Git: https://anonscm.debian.org/git/debian-science/packages/shark.git
Homepage: http://image.diku.dk/shark

Package: libshark0
Architecture: any
Multi-Arch: same
Section: libs
Depends: ${misc:Depends},
         ${shlibs:Depends}
Pre-Depends: ${misc:Pre-Depends}
Description: Shark machine learning library
 Shark is a modular C++ library for the design and optimization of adaptive
 systems. It provides methods for linear and nonlinear optimization, in
 particular evolutionary and gradient-based algorithms, kernel-based learning
 algorithms and neural networks, and various other machine learning techniques.
 .
 This package provides the Shark library.

Package: libshark0-dbg
Architecture: any
Multi-Arch: same
Section: debug
Priority: extra
Depends: ${misc:Depends},
         libshark0 (= ${binary:Version})
Description: debugging symbols for Shark
 Shark is a modular C++ library for the design and optimization of adaptive
 systems. It provides methods for linear and nonlinear optimization, in
 particular evolutionary and gradient-based algorithms, kernel-based learning
 algorithms and neural networks, and various other machine learning techniques.
 .
 This package provides the debugging symbols for the Shark library.

Package: libshark-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends: ${misc:Depends},
         libblas-dev | libblas.so,
         libboost-dev,
         libhdf5-dev,
         libshark0 (= ${binary:Version})
Suggests: shark-doc
Description: development files for Shark
 Shark is a modular C++ library for the design and optimization of adaptive
 systems. It provides methods for linear and nonlinear optimization, in
 particular evolutionary and gradient-based algorithms, kernel-based learning
 algorithms and neural networks, and various other machine learning techniques.
 .
 This package provides the development files for the Shark library.

Package: shark-doc
Architecture: all
Multi-Arch: foreign
Section: doc
Depends: ${misc:Depends},
         ${sphinxdoc:Depends},
         libjs-mathjax
Description: documentation and examples for Shark
 Shark is a modular C++ library for the design and optimization of adaptive
 systems. It provides methods for linear and nonlinear optimization, in
 particular evolutionary and gradient-based algorithms, kernel-based learning
 algorithms and neural networks, and various other machine learning techniques.
 .
 This package provides the documentation and example source code for the Shark
 library.
