=== debian/tests/control ===
Tests: build-examples
Depends: build-essential,
         cmake,
         libboost-date-time-dev,
         libboost-filesystem-dev,
         libboost-program-options-dev,
         libboost-system-dev,
         libboost-test-dev,
         libboost-thread-dev,
         libshark-dev,
         pkg-config,
         shark-doc
