## shark 3.1.0+ds1

=== CMakeLists.txt ===
--- 
+++ 
@@ -258,9 +258,21 @@
 		endif()
 		if(CBLAS_LIB_PATH)
 			find_file(CBLAS_INCLUDES cblas.h 
-				PATHS ${CBLAS_LIB_PATH} ${CBLAS_LIB_PATH}/../include ${CBLAS_LIB_PATH}/../../include/atlas
+				PATHS ${CBLAS_LIB_PATH} ${CBLAS_LIB_PATH}/../include
 			)
 			get_filename_component(CBLAS_INCLUDES ${CBLAS_INCLUDES} PATH )
+		endif()
+		if(ATLAS_LIBRARY)
+			get_filename_component(ATLAS_LIBRARY_PATH ${ATLAS_LIBRARY} PATH )
+			find_file(CLAPACK_INCLUDES clapack.h 
+				PATHS
+				${ATLAS_LIBRARY_PATH} 
+				${ATLAS_LIBRARY_PATH}/../include
+				${ATLAS_LIBRARY_PATH}/../include/atlas
+				${ATLAS_LIBRARY_PATH}/../../include/atlas
+			)
+			get_filename_component(CLAPACK_INCLUDES ${CLAPACK_INCLUDES} PATH )
+			set(CBLAS_INCLUDES ${CBLAS_INCLUDES} ${CLAPACK_INCLUDES})
 		endif()
 
 		if( OPENBLAS_LIBRARY AND CBLAS_INCLUDES)
@@ -315,13 +327,3 @@
 #####################################################################
 #                       Static Code Analysis
 #####################################################################
-option(USE_CPPCHECK "Use CPPCheck Static Code Analysis" OFF)
-mark_as_advanced(USE_CPPCHECK)
-if(USE_CPPCHECK)
-	find_program(CPP_CHECK cppcheck)
-	mark_as_advanced(CPP_CHECK)
-if(CPP_CHECK)
-	message(STATUS "cppcheck available for static code analysis." )
-	add_custom_target(code_analysis
-		${CPP_CHECK} --enable=all --xml --force -I${CMAKE_CURRENT_SOURCE_DIR}/include ${CMAKE_CURRENT_SOURCE_DIR} 2> StaticAnalysis.xml)
-	endif()
