=== debian/changelog ===
shark (3.1.0+ds1-1) unstable; urgency=medium

  * New upstream release.
  * Refresh patch queue.

 -- Ghislain Antony Vaillant <ghisvail@gmail.com>  Wed, 23 Mar 2016 11:26:27 +0000
