=== debian/rules ===
--- 
+++ 
@@ -41,9 +41,6 @@
 		-DOPT_INSTALL_DOCUMENTATION=ON
 
 override_dh_auto_test:
-ifneq ($(DEB_HOST_ARCH),i386)
-ifneq ($(DEB_HOST_ARCH),powerpc)
-ifneq ($(DEB_HOST_ARCH),armhf)
 ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
 	# Temporary override for buggy HDF5 testcase.
 	# See https://github.com/Shark-ML/Shark/issues/43
@@ -53,9 +50,6 @@
 	ctest --force-new-ctest-process -E "HDF5"
 	# Run HDF5 test executable manually.
 	cd obj-* && ./bin/Data_HDF5
-endif
-endif
-endif
 endif
 
 override_dh_installdocs-indep:
