## shark 3.1.1+ds1

=== debian/changelog ===
shark (3.1.1+ds1-1) unstable; urgency=medium

  * New upstream release.
  * Bump standards version to 3.9.8, no changes required.
  * Cherry-pick patch series fixing FTBFS on Stretch. (Closes: #831121)
  * Cherry-pick patch series fixing FTBFS of the testsuite. (Closes: #820701)
  * Remove test target override, no longer necessary.
  * Drop debug package in favor of autogenerated dbgsym.

 -- Ghislain Antony Vaillant <ghisvail@gmail.com>  Sun, 21 Aug 2016 17:37:51 +0100
