=== debian/control ===
--- 
+++ 
@@ -18,7 +18,7 @@
 Build-Depends-Indep: doxygen,
                      graphviz,
                      python-sphinx
-Standards-Version: 3.9.7
+Standards-Version: 3.9.8
 Vcs-Browser: https://anonscm.debian.org/cgit/debian-science/packages/shark.git
 Vcs-Git: https://anonscm.debian.org/git/debian-science/packages/shark.git
 Homepage: http://image.diku.dk/shark
@@ -37,21 +37,6 @@
  algorithms and neural networks, and various other machine learning techniques.
  .
  This package provides the Shark library.
-
-Package: libshark0-dbg
-Architecture: any
-Multi-Arch: same
-Section: debug
-Priority: extra
-Depends: ${misc:Depends},
-         libshark0 (= ${binary:Version})
-Description: debugging symbols for Shark
- Shark is a modular C++ library for the design and optimization of adaptive
- systems. It provides methods for linear and nonlinear optimization, in
- particular evolutionary and gradient-based algorithms, kernel-based learning
- algorithms and neural networks, and various other machine learning techniques.
- .
- This package provides the debugging symbols for the Shark library.
 
 Package: libshark-dev
 Architecture: any
