=== debian/rules ===
--- 
+++ 
@@ -27,7 +27,7 @@
 endif
 
 %:
-	dh $@ --parallel --dbg-package=libshark0-dbg
+	dh $@ --parallel
 
 override_dh_auto_configure-arch:
 	dh_auto_configure -- $(CMAKE_BUILD_OPTIONS) \
@@ -40,18 +40,6 @@
 		-DBUILD_EXAMPLES=ON \
 		-DOPT_INSTALL_DOCUMENTATION=ON
 
-override_dh_auto_test:
-ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
-	# Temporary override for buggy HDF5 testcase.
-	# See https://github.com/Shark-ML/Shark/issues/43
-	# Exclude HDF5 testcase from ctest.
-	cd obj-* && \
-	CTEST_OUTPUT_ON_FAILURE=1 \
-	ctest --force-new-ctest-process -E "HDF5"
-	# Run HDF5 test executable manually.
-	cd obj-* && ./bin/Data_HDF5
-endif
-
 override_dh_installdocs-indep:
 	dh_installdocs --indep
 	dh_doxygen --indep \
